#include <png++/png.hpp>

//The entire STL
#include <algorithm>
#include <allocators>
#include <array>
#include <bitset>
#include <cassert>
#include <ccomplex>
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <codecvt>
#include <complex>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdint>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <cwchar>
#include <cwctype>
#include <deque>
#include <exception>
#include <forward_list>
#include <fstream>
#include <functional>
#include <hash_map>
#include <hash_set>
#include <initializer_list>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <random>
#include <regex>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <strstream>
#include <system_error>
#include <tuple>
#include <type_traits>
#include <typeindeX>
#include <typeinfo>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <valarray>
#include <vector>
using namespace std;

struct Tile {
	uint8_t active;
	int16_t framex;
	int16_t framey;
	uint8_t lava;
	uint8_t light;
	int8_t liquid;
	int8_t type;
	int8_t wall;
};
bool tileFrameImportant[100];
#define Read(x) File.read((char*)&x,sizeof(x));
typedef png::rgba_pixel Color;

int main(int argc, char** argv) {
	if(argc<2){
		cout << "You idiot! Don't run this program directly! You're supposed to click and drag the .wld over the .exe!" << endl;
		cin.get();
		return 1;
	}
	{
		memset(tileFrameImportant,false,100);
		tileFrameImportant[3] = true;
		tileFrameImportant[5] = true;
		tileFrameImportant[10] = true;
		tileFrameImportant[11] = true;
		tileFrameImportant[12] = true;
		tileFrameImportant[13] = true;
		tileFrameImportant[14] = true;
		tileFrameImportant[15] = true;
		tileFrameImportant[16] = true;
		tileFrameImportant[17] = true;
		tileFrameImportant[18] = true;
		tileFrameImportant[20] = true;
		tileFrameImportant[21] = true;
		tileFrameImportant[24] = true;
		tileFrameImportant[26] = true;
		tileFrameImportant[27] = true;
		tileFrameImportant[28] = true;
		tileFrameImportant[29] = true;
		tileFrameImportant[31] = true;
		tileFrameImportant[33] = true;
		tileFrameImportant[34] = true;
		tileFrameImportant[35] = true;
		tileFrameImportant[36] = true;
		tileFrameImportant[42] = true;
		tileFrameImportant[50] = true;
		tileFrameImportant[55] = true;
		tileFrameImportant[61] = true;
		tileFrameImportant[71] = true;
		tileFrameImportant[72] = true;
		tileFrameImportant[73] = true;
		tileFrameImportant[74] = true;
		tileFrameImportant[77] = true;
		tileFrameImportant[78] = true;
		tileFrameImportant[79] = true;
	}

	/////////////////////////////////
	cout << "Parsing header" << endl;
	ifstream File(argv[1],ios::binary);
	string Path = argv[1];
	auto p1 = Path.find_last_of("/");
	auto p2 = Path.find_last_of("\\");
	if(p1!=Path.npos && (p1>=p2 || p2==Path.npos)){
		Path.erase(p1+1);
	} else if(p2!=Path.npos && (p2>=p1 || p1==Path.npos)){
		Path.erase(p2+1);
	} else {
		Path = "";
	}
	string Path2 = argv[0];
	p1 = Path2.find_last_of("/");
	p2 = Path2.find_last_of("\\");
	if(p1!=Path2.npos && (p1>=p2 || p2==Path2.npos)){
		Path2.erase(p1+1);
	} else if(p2!=Path2.npos && (p2>=p1 || p1==Path2.npos)){
		Path2.erase(p2+1);
	} else {
		Path2 = "";
	}
	int32_t Version;
	Read(Version);
	int8_t NameSize;
	Read(NameSize);
	char* Name = new char[NameSize+1];
	File.read(Name,NameSize);
	Name[NameSize] = 0;
	File.seekg(20,File.cur);
	int32_t Width, Height;
	Read(Height);
	Read(Width);
	File.seekg(8,File.cur);
	double Surface;
	Read(Surface);
	double Rock;
	Read(Rock);
	File.seekg(48,File.cur);
	Tile** Tiles = new Tile*[Width];

	////////////////////////////////
	cout << "Reading world" << endl;
	for(int x=0;x<Width;x++){
		Tiles[x] = new Tile[Height];
		for(int y=0;y<Height;y++){
			Read(Tiles[x][y].active);
			if(Tiles[x][y].active){
				Read(Tiles[x][y].type);
				if(tileFrameImportant[Tiles[x][y].type]){
					Read(Tiles[x][y].framex);
					Read(Tiles[x][y].framey);
				}
			}
			Read(Tiles[x][y].light);
			bool haswall;
			Read(haswall);
			if(haswall){
				Read(Tiles[x][y].wall);
			} else {
				Tiles[x][y].wall = 0;
			}
			bool hasliquid;
			Read(hasliquid);
			if(hasliquid){
				Read(Tiles[x][y].liquid);
				Read(Tiles[x][y].lava);
			} else {
				Tiles[x][y].liquid = 0;
				Tiles[x][y].lava = 0;
			}
		}
	}

	/////////////////////////////////
	cout << "Loading colors" << endl;
	ifstream CFile(Path2+"tilecolors.txt");
	struct TC {
		TC() {
			color = png::rgba_pixel(0,0,0,255);
		}
		TC(int r, int g, int b, int a) {
			color = png::rgba_pixel(r,g,b,a);
		}
		Color color;
		map<int,map<int,Color>> frame;
	};
	map<int,TC> TColors;
	while(!CFile.eof()){
		int type;
		CFile >> type;
		//if(tileFrameImportant[type]){
		//	while(!CFile.eof()){
		//		int x, y, r, g, b, a;
		//		CFile >> x;
		//		if(x<0){
		//			break;
		//		}
		//		CFile >> y >> r >> g >> b >> a;
		//		TColors[type].frame[x][y] = Color(r,g,b,a);
		//	}
		//} else {
			int r, g, b, a;
			CFile >> r >> g >> b >> a;
			TColors[type].color = Color(r,g,b,a);
		//}
	}

	///////////////////////////////////
	cout << "Generating image" << endl;
	png::image<png::rgba_pixel> Image(Width,Height);
#define c(r,g,b,a) png::rgba_pixel(r,g,b,a)
	for(int x=0;x<Width;x++){
		for(int y=0;y<Height;y++){
			Color c1;//Background
			Color c2;//Wall
			Color c3;//Tile
			Color c4;//Liquid

			///////////
			if(y>Rock){
				c1 = c(67,61,56,255);
			} else if(y>Surface){
				c1 = c(82,58,45,255);
			} else {
				c1 = c(68,130,254,255);
			}

			/////////////////////////
			switch(Tiles[x][y].wall){
			case 0:
				c2 = c(0,0,0,0);
				break;
			case 1:
				c2 = c(47,47,47,255);
				break;
			case 2:
				c2 = c(88,61,46,255);
				break;
			case 3:
				c2 = c(55,48,67,255);
				break;
			case 4:
				c2 = c(69,50,37,255);
				break;
			case 5:
				c2 = c(52,52,52,255);
				break;
			case 6:
				c2 = c(67,41,38,255);
				break;
			case 7:
				c2 = c(37,39,72,255);
				break;
			case 8:
				c2 = c(30,58,24,255);
				break;
			case 9:
				c2 = c(56,24,44,255);
				break;
			case 10:
				c2 = c(60,53,26,255);
				break;
			case 11:
				c2 = c(48,52,54,255);
				break;
			case 12:
				c2 = c(60,36,26,255);
				break;
			case 13:
				c2 = c(48,31,29,255);
				break;
			default:
				cout << "Unknown wall type: " << Tiles[x][y].wall << endl;
				break;
			}

			////////////////
			if(Tiles[x][y].active){
				//if(tileFrameImportant[Tiles[x][y].type]){
					//c3 = TColors[Tiles[x][y].type].frame[Tiles[x][y].framex][Tiles[x][y].framey];
				//} else {
					c3 = TColors[Tiles[x][y].type].color;
				//}
			} else {
				c3 = c(0,0,0,0);
			}

			///////////////////////
			if(Tiles[x][y].liquid){
				if(Tiles[x][y].lava){
					c4=c(255,0,0,127);
				} else {
					c4=c(0,0,255,127);
				}
			} else {
				c4=c(0,0,0,0);
			}

			Color cf = c1;
			cf.red = (double)cf.red*(255-c2.alpha)/255+(double)c2.red*c2.alpha/255;
			cf.green = (double)cf.green*(255-c2.alpha)/255+(double)c2.green*c2.alpha/255;
			cf.blue = (double)cf.blue*(255-c2.alpha)/255+(double)c2.blue*c2.alpha/255;
			cf.red = (double)cf.red*(255-c3.alpha)/255+(double)c3.red*c3.alpha/255;
			cf.green = (double)cf.green*(255-c3.alpha)/255+(double)c3.green*c3.alpha/255;
			cf.blue = (double)cf.blue*(255-c3.alpha)/255+(double)c3.blue*c3.alpha/255;
			cf.red = (double)cf.red*(255-c4.alpha)/255+(double)c4.red*c4.alpha/255;
			cf.green = (double)cf.green*(255-c4.alpha)/255+(double)c4.green*c4.alpha/255;
			cf.blue = (double)cf.blue*(255-c4.alpha)/255+(double)c4.blue*c4.alpha/255;
			Image[y][x] = cf;
		}
	}

	///////////////////////////////////////////////////////
	cout << "Saving image as " << Path+Name+".png" << endl;
	Image.write(Path+Name+".png");

	////////////////////////
	cout << "Done!" << endl;
	cin.get();
	return 0;
}